# index.tcl - This file dispatches the different states in the
# application to the controlling logic.

# $Id: index.tcl,v 1.2 2004/04/10 17:45:32 davidw Exp $
set auto_path ". $auto_path"
package require dispatch

# Tell the gui subsystem that we are using the web interface.
set iface web
package require chatgui
package require chatlogic

dispatch::init

# Default state - send the user to the login page.

dispatch::state default {
    chat::gui::login
}

# Dispatch either to the login logic or new user logic, depending on
# which button was pushed.

dispatch::state login {
    if { ! [var exists newuser] } {
	chat::logic::login [var get nick] [var get pass]
    } else {
	chat::gui::newuser [var get nick] [var get pass]
    }
}

# Retrieves the current conversation to the display frame.

dispatch::state chatdata {
    set nick [var get nick]
    set lines [chat::model::getlines $nick]
    parse display.rvt
}

# Displays who is on line.

dispatch::state who {
    set nick [var get nick]
    parse who.rvt
}

# The input frame.

dispatch::state input {
    set nick [var get nick]
    parse input.rvt
}

# Dispatch to new user logic.

dispatch::state newuser {
    chat::logic::newuser [var get nick] [var get pass] [var get pwconfirm]
}

# Receive message and dispatch to logic for user messages.

dispatch::state chat {
    chat::logic::chat [var get nick] [var get msg]
}

dispatch::dispatch